$lightcolor: #fff;
$darkcolor: #333;

$gray: #dfe6e9;
$lightgray: #f0f0f0;
$red: #d63031;
$lightred: #fab1a0;
$blue: #0984e3;
$lightblue: #74b9ff;
$green: #00b894;
$lightgreen: #55efc4;
$yellow: #fdcb6e;
$lightyellow: #ffeaa7;
$violet: #6c5ce7;
$lightviolet: #a29bfe;

@mixin colored($backgroundcolor, $color) {
    $hover: darken($backgroundcolor, 8%);
    $active: darken($hover, 4%);
    $outlineColor: $hover;

    background-color: $backgroundcolor;
    color: $color;

    &:hover, &:focus {
        background-color: $hover;
    }

    &:active {
        background-color: $active;

        &.outlined {
            box-shadow: 0px 0px 3px 0px $outlineColor;
        }
    }

    &.bordered {
        border: 1px solid $hover;

        &:hover, &:focus {
            border-color: $active;
        }

        &:active {
            border-color: $outlineColor;
        }
    }

    &.left-to-right {
        position: relative;

        &:active {
            &::before {
                position: absolute;
                content: ' ';
                left: 0;
                top: 0;
                bottom: 0;
                background: rgba($backgroundcolor, 0.5);
                animation-name: leftToRight;
                animation-duration: 0.3s;
                animation-timing-function: linear;
            }
        }
    }

    &.right-to-left {
        position: relative;

        &:active {
            &::before {
                position: absolute;
                content: ' ';
                left: 0;
                top: 0;
                bottom: 0;
                background: rgba($backgroundcolor, 0.5);
                animation-name: rightToLeft;
                animation-duration: 0.3s;
                animation-timing-function: linear;
            }
        }

    }
}

button, .button {
    border: 0;
    padding: 10px 20px;
    outline: none;
    cursor: pointer;
    @include colored($gray, $darkcolor);

    &.rounded {
        border-radius: 6px;
        -webkit-border-radius: 6px;
        -moz-border-radius: 6px;
        -ms-border-radius: 6px;
        -o-border-radius: 6px;
    }

    &.gray {
        @include colored($gray, $darkcolor);
    }

    &.lightgray {
        @include colored($lightgray, $darkcolor);
    }

    &.red {
        @include colored($red, $lightcolor);
    }

    &.lightred {
        @include colored($lightred, $lightcolor);
    }

    &.blue {
        @include colored($blue, $lightcolor);
    }

    &.lightblue {
        @include colored($lightblue, $lightcolor);
    }

    &.green {
        @include colored($green, $lightcolor);
    }

    &.lightgreen {
        @include colored($lightgreen, $lightcolor);
    }

    &.yellow {
        @include colored($yellow, $lightcolor);
    }

    &.lightyellow {
        @include colored($lightyellow, $lightcolor);
    }

    &.violet {
        @include colored($violet, $lightcolor);
    }

    &.lightviolet {
        @include colored($lightviolet, $lightcolor);
    }

}

@keyframes leftToRight {
    0% {
        left: 0%;
        right: 100%;
    }

    33% {
        left: 0%;
        right: 50%;
    }

    67% {
        left: 50%;
        right: 0;
    }

    100% {
        left: 100%;
        right: 0%;
    }
}

@keyframes rightToLeft {
    0% {
        left: 100%;
        right: 0;
    }

    33% {
        left: 50%;
        right: 0;
    }

    67% {
        left: 0;
        right: 50%;
    }

    100% {
        left: 0;
        right: 100%;
    }
}